import numpy as np
import os, sys
from datetime import datetime, timedelta
import shutil
import glob


outdir = "/ships19/grain/jcintineo/GLM/fix/ge/"

startdt = dt = datetime(2023, 10, 19, 15, 7)
enddt = datetime(2023, 10, 19, 15, 18)  # startdt + timedelta(days=1)

while startdt <= dt < enddt:
    print(dt)
    pattern = dt.strftime(
        "/arcdata/goes/grb/goes18/%Y/%Y_%m_%d_%j/glm/L2/LCFA/*s%Y%j%H%M*"
    )
    remotefiles = glob.glob(pattern)
    if len(remotefiles) == 3:  # should be 3 files per minute

        cmd = (
            "python glmtools/examples/grid/make_GLM_grids.py -o "
            + outdir
            + "/{start_time:%Y/%b/%d}/{dataset_name} --fixed_grid --split_events --goes_position west --goes_sector conus --dx 2.0 --dy 2.0"
        )

        for rf in remotefiles:
            shutil.copy(rf, f"{os.environ['PWD']}/")
            cmd += f" {os.path.basename(rf)}"
        os.system(cmd)

        for rf in remotefiles:
            os.remove(os.path.basename(rf))

        dt += timedelta(minutes=1)
