import numpy as np
from earth_to_fgf import earth_to_fgf
import sys
import time

t0 = time.time()

lats = np.array(
    [
        36.35,
        36.35,
        36.35,
        36.35,
        36.35,
        36.35,
        36.34,
        36.33,
        36.32,
        36.31,
        36.3,
        36.29,
        36.28,
        36.27,
        36.26,
        36.25,
        36.24,
        36.23,
        36.22,
        36.21,
        36.2,
        36.19,
        36.18,
        36.17,
        36.16,
        36.15,
        36.15,
        36.14,
        36.14,
        36.14,
        36.15,
        36.16,
        36.17,
        36.18,
        36.19,
        36.2,
        36.21,
        36.22,
        36.23,
        36.24,
        36.25,
        36.26,
        36.27,
        36.28,
        36.29,
        36.3,
        36.31,
        36.32,
        36.33,
        36.34,
        36.35,
    ]
)

lons = np.array(
    [
        -82.52,
        -82.51,
        -82.5,
        -82.49,
        -82.48,
        -82.47,
        -82.46,
        -82.45,
        -82.45,
        -82.45,
        -82.45,
        -82.45,
        -82.45,
        -82.45,
        -82.46,
        -82.46,
        -82.45,
        -82.45,
        -82.45,
        -82.44,
        -82.44,
        -82.44,
        -82.44,
        -82.44,
        -82.44,
        -82.45,
        -82.46,
        -82.47,
        -82.48,
        -82.49,
        -82.5,
        -82.51,
        -82.52,
        -82.52,
        -82.53,
        -82.54,
        -82.55,
        -82.56,
        -82.57,
        -82.57,
        -82.58,
        -82.58,
        -82.58,
        -82.58,
        -82.58,
        -82.57,
        -82.56,
        -82.55,
        -82.54,
        -82.53,
        -82.52,
    ]
)

inds = earth_to_fgf(lats, lons)

# subtract, round, cast as ints, and zip to find unique ind pairs
uniq_inds = set(
    [
        (x, y)
        for x, y in zip(
            (np.round(inds[0] - 1.5)).astype(int), (np.round(inds[1] - 1.5)).astype(int)
        )
    ]
)
# then unzip for indexing purposes
glm_inds = zip(*uniq_inds)

print(time.time() - t0)

print(glm_inds)

# answer: [(98, 98, 97, 97, 96, 96), (297, 296, 296, 297, 297, 296)]
