import json
import numpy as np
import sys
from datetime import datetime, timedelta

sat = "G17"  # G16 G17

f = open(f"static/{sat}_fov_lat.csv", "r")
all_lats = f.read()
f.close()
lats = [float(x) for x in all_lats.split(",")]

f = open(f"static/{sat}_fov_lon.csv", "r")
all_lons = f.read()
f.close()
# All pos lons
lons = [float(x) % 360 for x in all_lons.split(",")]

coords = [[x, y] for x, y in zip(lons, lats)]
coords.append(coords[0])  # "close" the "polygon"

# Now make identical shape with all neg lons. This is a hack to get it to work in RealEarth/Leaflet.
coordsNEG = []
for ll in coords:
    coordsNEG.append([(ll[0] - 360) % (-360), ll[1]])

all_feats = {"type": "FeatureCollection", "features": []}

for cc in [coords, coordsNEG]:
    all_feats["features"].append(
        {
            "type": "Feature",
            "geometry": {"type": "LineString", "coordinates": cc},
            "properties": {
                "OPACITY": "0",
                "BOPACITY": "100",
                "COLOR": "128 0 128",
                "BCOLOR": "128 0 128",
                "WIDTH": "3",
            },
        }
    )


json_obj = json.dumps(all_feats, indent=2)

dt = datetime.utcnow()
with open(dt.strftime(f"{sat}-GLM-FOV_%Y%m%d_%H%M00.force.json"), "w") as outfile:
    outfile.write(json_obj)
