import zarr
from lightningcast.solar_angles import solar_angles
from datetime import datetime, timedelta
from lightningcast import utils
import os, sys
import numpy as np


ds = zarr.open(
    "/apollo/grain/jcintineo/AI/OCONUS/seg/unet_train400_5frames_2020test.zarr/", "a"
)

abi_date = ds.ABI_date[:]
abi_time = ds.ABI_time[:]

dts = [
    datetime.strptime(str(d) + str(t), "%Y%m%d%H%M") for d, t in zip(abi_date, abi_time)
]

newgrid, ny, nx, lons, lats = utils.get_area_definition(
    "static/GOES_East.nc", return_latlons=True
)

# our "offshore" region for initial training

# with respect to GOES-East 2km ABI CONUS grid
startX = 1510
endX = 1910  # 2310
startY = 450  # 50
endY = 850  # this should be north of the "Bermuda bars/strobes"

lats = lats[startY:endY, startX:endX]
lons = lons[startY:endY, startX:endX]

# container
all_solzen = np.empty((len(dts), 400, 400))

for i in range(len(dts)):
    print(i)
    solzen, _ = solar_angles(dt=dts[i], lon=lons, lat=lats)
    all_solzen[i] = solzen

chunks = (1, 400, 400)


newarr = ds.zeros(
    "solzen", shape=all_solzen.shape, chunks=chunks, dtype=all_solzen.dtype
)
newarr[:] = all_solzen

# create data
# if(ds_exists): #just append along time axis
#    newarr = zarr.zeros(datasets[f]['data'].shape, chunks=chunks,dtype=str(datasets[f]['data'].dtype))
#    newarr[:] = datasets[f]['data']
#    root[f].append(newarr,axis=0)
# else: #start of new data array in group
#    newarr = root.zeros(f,shape=datasets[f]['data'].shape, chunks=chunks,dtype=str(datasets[f]['data'].dtype))
#    newarr[:] = datasets[f]['data']
#    #set attributes
#    for att in datasets[f]['atts']:
#        newarr.attrs[att] = datasets[f]['atts'][att]
